<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 2: Types, Operators, and Expressions</title>
<link href="sx4n.html" rev=precedes>
<link href="sx5a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 2: Types, Operators, and Expressions</H1>

<p>page 35
</p><p>Deep sentence:
<blockquote>The type of an object determines the set of values it can have
and what operations can be performed on it.
</blockquote>This is a fairly formal, mathematical definition of what a type is,
but it is traditional (and meaningful).
There are several implications to remember:
</p><OL><li>The ``set of values'' is
finite.
C's <TT>int</TT> type can not represent <em>all</em> of the integers;
its <TT>float</TT> type can not represent <em>all</em> 
floating-point numbers.
<li>When you're using an object (that is, a variable) of some type,
you
may
have to remember what values it can take on and what 
operations you can perform on it.
For example,
there are several operators which
play with

the binary (bit-level) representation of integers,
but these operators
are not meaningful for
and may not be applied to
floating-point operands.
<li>When declaring a new variable and picking a type for it,
you have to keep in mind the values and operations you'll be needing.
</OL>In other words,
picking a type for a variable is not some abstract academic exercise;
it's closely
connected
to the way(s) you'll be using that variable.
<p>You don't need to worry about
the
list of ``small changes and additions'' made by the ANSI standard,
unless you started learning C long ago or have a keen interest 
in its history.
We'll be using these new features indiscriminately,
usually without comment.

</p><p><a href="sx5a.html" rel=subdocument>section 2.1: Variable Names</a></p>
<p><a href="sx5b.html" rel=subdocument>section 2.2: Data Types and Sizes</a></p>
<p><a href="sx5c.html" rel=subdocument>section 2.3: Constants</a></p>
<p><a href="sx5d.html" rel=subdocument>section 2.4: Declarations</a></p>
<p><a href="sx5e.html" rel=subdocument>section 2.5: Arithmetic Operators</a></p>
<p><a href="sx5f.html" rel=subdocument>section 2.6: Relational and Logical Operators</a></p>
<p><a href="sx5g.html" rel=subdocument>section 2.7: Type Conversions</a></p>
<p><a href="sx5h.html" rel=subdocument>section 2.8: Increment and Decrement Operators</a></p>
<p><a href="sx5i.html" rel=subdocument>section 2.9: Bitwise Operators</a></p>
<p><a href="sx5j.html" rel=subdocument>section 2.10: Assignment Operators and Expressions</a></p>
<p><a href="sx5k.html" rel=subdocument>section 2.11: Conditional Expressions</a></p>
<p><a href="sx5l.html" rel=subdocument>section 2.12: Precedence and Order of Evaluation</a></p>
<hr>
<p>
Read sequentially:
<a href="sx4n.html" rev=precedes>prev</a>
<a href="sx5a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
